// ProgramFour.cpp : Defines the entry point for the console application.
//


#include "stdafx.h"
#include "ProgramFour.h"
#include <iostream>
#include <string>
#include "HighResolutionTime.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// The one and only application object

CWinApp theApp;

using namespace std;

int searchForLastName(string lastName);

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;
	char c;

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// Error!  This should never happen
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		nRetCode = 1;
	}

	//////////////////////////////////////////
	// This is where the real program starts
	//////////////////////////////////////////
	else
	{
		
		string lastName;

		cout << "Enter the last name you want to search for in the grade record database: ";
		cin  >> lastName;
	
		cin.get(c);


		int result = searchForLastName(lastName);

		cout << "Found " << result << " occurrences of " << lastName << endl;
	}

	cout << "Press ENTER to terminate..." << endl;
	cin.get(c);

	return nRetCode;
}


int searchForLastName(string lastName) 
{
	CDatabase db;
	int result=0;

	BOOL rc = db.Open(NULL,FALSE,FALSE,
						  _T("ODBC;DSN=CS325;UID=SCOTT;PWD=TIGER;"),
						  TRUE);

	if (!rc) {
		cout << "Database Connection failed." << endl;
		exit(0);
	}

	
	// Use forwardOnly type recordset for best
	// performance, since only MoveNext is required
	CRecordset rs( &db );

	rs.Open( CRecordset::forwardOnly,
			 _T( "SELECT * FROM student,course,grade where student.ssn=grade.ssn and course.id=grade.id" ) );

	// Loop through the recordset,
	long count=0;
	while( !rs.IsEOF() ) {

		// Create a CDBVariant object to
		// store field data
		CDBVariant lname;
		rs.GetFieldValue( "LAST", lname );
	
		if (!strcmp((LPCTSTR) (*lname.m_pstring), lastName.c_str())){
			result++;
		}


		rs.MoveNext();

		count++;
		if ((count % 1000) == 0) {
			cout << ".";
			cout.flush();
		}
	}

	cout << endl;

	rs.Close();
	db.Close();

	return result;
}
